//
// GameX (Release 2 - Vectors / Matricies / CameraX)
// Vector Class Code 
// 
// Copyright (C) 2002 Rama C. Hoetzlein
// 
// This software is released under the GameX GNU GPL 
// Open Source Liscense. See the GameX documentation included
// with this source code for terms of modification, 
// distribution and re-release. 
//


#include "gamex-vector.hpp"
#include "gamex-matrix.hpp"

Vector3DF &Vector3DF::operator*= (MatrixF &op)
{
	double *m = op.GetDataF ();
	double xa, ya, za;
	xa = x * (*m++);	ya = x * (*m++);	za = x * (*m++);	m++;
	xa += y * (*m++);	ya += y * (*m++);	za += y * (*m++);	m++;
	xa += z * (*m++);	ya += z * (*m++);	za += z * (*m++);	m++;
	xa += (*m++);		ya += (*m++);		za += (*m++);
	x = xa; y = ya; z = za;
	return *this;
}


Vector4DF &Vector4DF::operator*= (MatrixF &op)
{
	double *m = op.GetDataF ();
	double xa, ya, za, wa;
	xa = x * (*m++);	ya = x * (*m++);	za = x * (*m++);	wa = x * (*m++);
	xa += y * (*m++);	ya += y * (*m++);	za += y * (*m++);	wa += y * (*m++);
	xa += z * (*m++);	ya += z * (*m++);	za += z * (*m++);	wa += z * (*m++);
	xa += w * (*m++);	ya += w * (*m++);	za += w * (*m++);	wa += w * (*m++);
	x = xa; y = ya; z = za; w = wa;
	return *this;
}